/*WP Ajax Edit Script
--Created by Ronald Huereca
--Created on: 03/28/2007
--Last modified on: 05/25/2007
--Relies on jQuery
Classnames referenced in here for the Author are:
	editAuthor (default)
	editableAuthor (Shows it can be edited)
	textAuthor (When the author field is being edited)
Classnames referenced in here for the Comment are:
	editComment (default)
	editableComment (Shows it can be edited)
	textComment (When the comment field is being edited)
	
	Copyright 2007  Ronald Huereca  (email : ron alfy [a t ] g m ail DOT com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
<?php
if (!function_exists('add_action'))
{
	require_once("../../../../wp-config.php");
}
?>
jQuery(document).ready(function(){
   AjaxEditComments.init();
});
var AjaxEditComments = function() {
	var $j = jQuery;
	var PluginUrl = "<?php bloginfo('wpurl') ?>/wp-content/plugins/wp-ajax-edit-comments";
	var CommentAuthorName = "editAuthor";
	var CommentClassName = "editComment";
	var EditCommentAuthorName = "editableAuthor"; //not edible author :)
	var EditCommentClassName = "editableComment";
	var TextAuthorClassName = "textAuthor";
	var TextCommentClassName = "textComment";
	//Scans the spans and divs for a specific class and sets events to make them editable
	function MakeEdit() {
			//Make the Author portions editable
		$j('.' + CommentAuthorName).mouseover = function() { ShowAsEditable(this);
		$j('.' + CommentAuthorName).mouseout = function() { ShowAsUnEditable(this);
		$j('.' + CommentAuthorName).click = function() { Edit(this);
		
		//Make the comment portions editable
		$j('.' + CommentClassName).mouseover = function() { ShowAsEditable(this);
		$j('.' + CommentClassName).mouseout = function() { ShowAsUnEditable(this);
		$j('.' + CommentClassName).click = function() { Edit(this);
	}
	//Allows the comment and author areas to be editable
	//obj - The object that triggered the event
	function Edit(obj) {
		obj = $j(obj);
		if (obj.is("span")) {
			//Create a new span element to replace the author span
			var newSpan = '<span class="' + TextAuthorClassName + '" id="' + TextAuthorClassName + obj.id + '">'
				
			//if url and name both return zero matches, use innerHTML as is.
			var url = obj.html().match(/href=\"([^"]*)\"/i);
			if (url == undefined) { url = obj.html().match(/href=\'([^']*)\'/i)	}
			if (url == undefined) {
				url = '';
				name = obj.html();
			} else {
				url = url[1];
				name = obj.html().match(/>([^<]*)<\/a>/i)[1];
			}
			
			var authorInputBox = '<label for="' + obj.id + '_URL">URL: </label><input type="text" class="authorURL" id="' + obj.id + '_URL" value="' + url + '" /><label for="' + obj.id + '_author"> Name: </label><input type="text" id="' + obj.id + '_author" class="authorInput" value=\'' + name + '\' />&nbsp;&nbsp;';
			var authorButtons = '<input type="button" value="Save" id="' + obj.id + '_saveAuthor" /> or <input type="button" value="Cancel" id="' + obj.id + '_cancelAuthor" />';
			newSpan = newspan + authorInputBox + authorButtons + "</span>";
			
			//Hide the old span
			obj.hide();
			obj.before(newSpan);
			
			//Setup save and cancel button events
			var saveButton = $j(obj.id + "_saveAuthor");
			var cancelButton = $j(obj.id + "_cancelAuthor");
			saveButton.click = function() { AuthorSave(this, obj); }
			cancelButton.click = function() { EditCancel(this, obj, $j("#" + TextAuthorClassName + obj.id)); }
			
		} else if (obj.is(div)) {
			var newDiv = '<div class="' + TextCommentClassName + '" id="' + TextCommentClassName + obj.id + '">';
			//Create the input box and buttons
			var textarea = '<textarea id="' + obj.id + '_edit" name="' + obj.id + '">Loading comment...</textarea>';
			var commentButtons = '<p><input type="button" value="Save" id="' + obj.id + '_saveComment" /> or <input type="button" value="Cancel" id="' + obj.id + '_cancelComment" /></p>';
			
			//Load the comment
			$j.ajax({
				type: "post",
				url: PluginURL + '/php-includes/AjaxEditComments.php',
				timeout: 15000,
				data: 'GetCommentId=' + obj.id,
				success: LoadCommentComplete,
				error: LoadCommentFailure
			})
					
			newDiv = newDiv + textarea + commentButtons + "</div";
			//Hide the old span and show the new one
			obj.hide();
			obj.before(newDiv);
			
			//Setup save and cancel button events
			var saveButton = $j(obj.id + "_saveComment");
			var cancelButton = $j(obj.id + "_cancelComment");
			saveButton.click = function() { CommentSave(this, $j("#" + TextCommentClassName + obj.id), "block", saveButton); }
			cancelButton.click = function() { EditCancel(this, obj, $j("#" + TextCommentClassName + obj.id)); }
			
		} 
	}
	//Changes the classname of the span/div so that it appears editable
	function ShowAsEditable(obj) {
		obj = $j(obj);
		if (obj.attr("class") = CommentAuthorName) {
			obj.attr("class") = EditCommentAuthorName;
		} else if (obj.attr("class") = CommentClassName) {
			obj.attr("class") = EditCommentClassName;			
		}
	}
	//Changes the classname of the span/div so that it appears uneditable
	function ShowAsUnEditable(obj) {
		obj = $j(obj);
		if (obj.attr("class") = EditCommentAuthorName) {
			obj.attr("class") = CommentAuthorName;
		} else if (obj.attr("class") = EditCommentClassName) {
			obj.attr("class") = CommentClassName;			
		}
	}
	//Saves the Author Data to the Database
	//saveButton - The save button
	//oldSpan - The element to show saved information
	//newSpan - The element to retreive saved information
	//display - The display type of the oldspan
	function AuthorSave(saveButton, oldSpan) {
		var url = $j(oldSpan.id + "_URL");
		var author = $j(oldSpan.id + "_author");
		
		saveButton.attr("value", "Saving...");
		saveButton.attr("disabled", "disabled");
		if (url == undefined || author == undefined) { saveButton.attr("value", "Saving Author Failed"); return; }
		urlValue = url.attr("value");
		authorValue = author.attr("value");
		
		$j.ajax({
				type: "post",
				url: PluginURL + '/php-includes/AjaxEditComments.php',
				timeout: 15000,
				data: 'SaveAuthorCommentId=' + oldSpan.id + '&AuthorURL=' + encodeURIComponent(url.attr("value")) + '&AuthorName=' + encodeURIComponent(author.attr("value")),
				success: SaveAuthorComplete,
				error: SaveAuthorFailure
			})
	}
	//Cancels an Edit
	//evt - The event object
	//obj1 - The element to show
	//obj2 - The element to destroy
	//display - The display type of object 1
	function EditCancel(cancelButton, obj1, obj2) {
		obj2.remove();
		obj1.show();
	}
	//Saves the comment data to the database
	//saveButton - The save button
	//oldDiv - The original argument
	function CommentSave(saveButton, oldDiv) {
		var textarea = $j(oldDiv.id + "_edit");
		saveButton.attr("value", "Saving...");
		saveButton.attr("disabled", "disabled");
		
		$j.ajax({
				type: "post",
				url: PluginURL + '/php-includes/AjaxEditComments.php',
				timeout: 15000,
				data: 'SaveCommentId=' + oldDiv.id + '&SaveContent=' + encodeURIComponent(textarea.attr("value")),
				success: SaveAuthorComplete,
				error: SaveAuthorFailure
			})
	}
	function LoadCommentComplete() {
		alert("load comment complete");
		
	}
	function LoadCommentFailure() {
		alert("load comment failure");
		
	}
	function SaveCommentComplete() {
		alert("save comment complete");
		
	}
	function SaveCommentFailure() {
		alert("save comment failure");
		
	}
	function SaveAuthorComplete() {
		alert("save author complete");
		
	}
	function SaveAuthorFailure() {
		alert("save author failure");
		
	}
	return {
			init : function() { //AKA the constructor
				
			},
			trim: function(string) {
				return string.replace(/^\s+|\s+$/g, '') ;	
			}
	};
	
}();


/*


function wpAjaxLoadCommentComplete(t, id) {
	var textBox = document.getElementById(id + "_edit");
	if (textBox == undefined) {
		//nothing to do so we return
		return;
	}
	
	if (t == 0) {
			textBox.value = "Load comment failed";
			return;
	}
	//todo time out
	textBox.value = t;
}
function wpAjaxLoadCommentFailure(t, id) {
	var textBox = document.getElementById(id + "_edit");
	if (textBox == undefined) {
		//nothing to do so we return
		return;
	}
	
	if (t == 0) {
			textBox.value = "Load comment failed.";
			return;
	}
}
function wpAjaxSaveAuthorComplete(t, obj1, obj2, display, saveButton) {
	if (obj1 == undefined || obj2 == undefined || saveButton == undefined) { 
		return;
	}
	if (t == 0) {
			saveButton.value = "Save Author Failed";
			return;
	}

	//todo time out
	obj1.innerHTML = t;
	obj1.style.display = display;
	var p = obj2.parentNode;
	p.removeChild(obj2); 
}
function wpAjaxSaveAuthorFailure(t, saveButton) {
	if (saveButton == undefined) { return; }
	saveButton.value = "Save Author Failed";
}
function wpAjaxSaveCommentComplete(t, obj, obj2, display, saveButton) {
	if (obj == undefined || obj2 == undefined || saveButton == undefined) { return; }
	
	if (t == 0) { 
		saveButton.value = "Save Comment Failed";
		return;
	}
	

	//todo time out
	obj.innerHTML = t;
	obj.style.display = display;
	var p = obj2.parentNode;
	p.removeChild(obj2);
}
function wpAjaxSaveCommentFailure(t, id, saveButton) {
	if (saveButton == undefined) { return; }
	saveButton.value = "Save Author Failed";
}
*/